<?php

/*
 plugin delivery
 System event: OnSHKbeforeCartLoad
*/

$eventName = $modx->event->name;
$output = '';

if($eventName=='OnSHKbeforeCartLoad'){
    
    require_once MODX_CORE_PATH."components/shopkeeper/include.parsetpl.php";
    $modx->addPackage('shopkeeper',MODX_CORE_PATH."components/shopkeeper/model/");
    
    $default_tpl = '@INLINE <option value="[[+name]]" [[+selected]]>[[+name]] [[+price:gt=`0`:then=`([[+price]] руб.)`]]</option>';
    $tpl = $modx->getOption('tpl',$scriptProperties,$default_tpl);
    $deliveryName = $modx->getOption('deliveryName',$scriptProperties,'Доставка');
    $toPlaceholder = 'shk_delivery';
    
    $curSavedP = !empty($_SESSION['shk_purchases']) ? $_SESSION['shk_purchases'] : array();
    $curSavedA = !empty($_SESSION['shk_addit_params']) ? $_SESSION['shk_addit_params'] : array();
    $purchases = array();
    $addit_params = array();

    //достаём из БД конфигурацию модуля с данными вариантов доставки
    $config = $modx->getCollection('SHKconfig');
    $shk_config = array();
    foreach ($config as $conf) {
      $confArray = $conf->toArray();
      if($confArray['setting'] == 'statuses')
          $shk_config[$confArray['setting']] = unserialize($confArray['value']);
      else if($confArray['setting'] == 'delivery')
          $shk_config[$confArray['setting']] = unserialize($confArray['value']);
      else
          $shk_config[$confArray['setting']] = $confArray['value'];
    }
    
    $selected_delivery = '';
    
    //если в корзине только доставка, очищаем корзину
    if(count($curSavedP)==1 && isset($curSavedP[0]['name']) && $curSavedP[0]['name']==$deliveryName){
        $_SESSION['shk_purchases'] = array();
        $_SESSION['shk_addit_params'] = array();
        unset($_SESSION['shk_purchases'],$_SESSION['shk_addit_params']);
    }
    
    //Сохраняем данные выбранного способа доставки
    if(isset($_POST['shk_delivery']) && count($curSavedP)>0){

        $selected_delivery = $_POST['shk_delivery'];

        //выкидываем старую доставку
        foreach($curSavedP as $key => $val){
            if(!isset($val['name']) || $val['name']!=$deliveryName){
                $purchases[] = $val;
                $addit_params[] = $curSavedA[$key];
            }
        }
        unset($key,$val);

        //добавляем доставку в заказ
        foreach($shk_config['delivery'] as $key => $val){
            if($val[0] == $selected_delivery && !empty($val[1])){
                $dlvr = array();
                $val[1] = floatval(str_replace(',','.',$val[1]));
                $dlvr[0] = array('id'=>0,'count'=>1,'price'=>0,'name'=>$deliveryName);
                $dlvr[0]['tv_add']['shk_delivery'] = $val[0];
                $addit = array();
                $addit[0][] = array($val[0],$val[1]);
                $purchases = array_merge($purchases,$dlvr);
                $addit_params = array_merge($addit_params,$addit);
                break;
            }
        }
        unset($key,$val,$dlvr);
        $_SESSION['shk_purchases'] = $purchases;
        $_SESSION['shk_addit_params'] = $addit_params;

    //Определяем текущий способ доставки
    }else{

        foreach($curSavedP as $key => $val){
            if(isset($val['name']) && $val['name']==$deliveryName){
                $selected_delivery = isset($curSavedA[$key][0][0]) ? $curSavedA[$key][0][0] : '';
                break;
            }
        }
        unset($key,$val);

    }

    $chunkArr = array();
    foreach($shk_config['delivery'] as $key => $val){
        $chunkArr = array(
            'name' => $val[0],
            'price' => $val[1],
            'selected' => $val[0] == $selected_delivery ? ' selected="selected" ' : ''
        );
        $output .= parseTpl($tpl, $chunkArr);
    }

    if($toPlaceholder){
        $modx->setPlaceholder($toPlaceholder,$output);
        $output = '';
    }
    
    $modx->event->output($output);
    
}


return;

?>
