<?php

//***********************************
//snippet for MODx 2.x
//***********************************

/*

Код сниппета:
return require MODX_CORE_PATH."components/shopkeeper/elements/snippets/param_edit_table.php";
или
[[include?
&file=`core/components/shopkeeper/elements/snippets/param_edit_table.php`
&tvName=`param1`
&tpl=`properties_table`
]]

Примеры чанка:

1.

<h1>Заголовок</h1>
[[+inner]]
<!--tpl_separator-->
<div class="one">
    <img src="[[+field1+]]" width="203" height="144" alt="" />
    <h3>[[+field2+]]</h3>
    <p>[[+field3+]]</p>
</div>

2.

<table>[[+inner]]</table>
<!--tpl_separator-->
<tr>
    [[+inner]]
</tr>
<!--tpl_separator-->
<td>[[+col_num]]. [[+field]]</td>


*/

if(!isset($docId)) $docId = $modx->resource->get('id');
if(!isset($tvName)) $tvName = 'param';
if(!isset($tpl)) $tpl = '';
if(!isset($postName)) $postName = 'none';
$output = '';

if(!function_exists('fetchTpl')){
function fetchTpl($tpl){
    global $modx;
    $template = "";
    if(substr($tpl, 0, 6) == "@FILE:"){
      $tpl_file = MODX_BASE_PATH . substr($tpl, 6);
        $template = file_get_contents($tpl_file);
    }else if(substr($tpl, 0, 6) == "@CODE:"){
        $template = substr($tpl, 6);
    }else if($modx->getChunk($tpl) != ""){
        $template = $modx->getChunk($tpl);
    }else{
        $template = false;
    }
    return $template;
}
}

$tv = $modx->getObject('modTemplateVar',array('name'=>$tvName));

if($tv){
    
    $TVout = $tv->getValue($docId);//$tv->renderOutput($docId);
    $rowChunk = explode('<!--tpl_separator-->', fetchTpl($tpl));
    $fields = explode('||',$TVout);
    
    if(strlen($TVout)==0) return '';
    
    foreach($fields as $key => $val){
        $row = explode('==',$val);
        $rowArr = array('[[+inner]]'=>'');
        foreach($row as $k => $v){
            $rowArr['field'.($k+1)] = $v;
            if(isset($_POST[$postName])){
                $selected = $_POST[$postName] == $v ? ' selected="selected"' : '';
            }else{
                $selected = isset($modx->placeholders['form_'.$postName]) && $modx->placeholders['form_'.$postName] == $v ? ' selected="selected"' : '';
            }
            $rowArr['selected'.($k+1)] = $selected;
            $colArr = array(
                'col_num' => $k+1,
                'field' => $v
            );
            if(!isset($col_unique)) $col_unique = uniqid();
            $chunk = $modx->newObject('modChunk');
            $chunk->fromArray(array('name'=>"@INLINE-{$col_unique}",'snippet'=>(isset($rowChunk[2]) ? $rowChunk[2] : '')));
            $rowArr['inner'] .= $chunk->process($colArr);
        }
        if(strlen($rowArr['inner'])>0){
            if(!isset($row_unique)) $row_unique = uniqid();
            $chunk = $modx->newObject('modChunk');
            $chunk->fromArray(array('name'=>"@INLINE-{$row_unique}",'snippet'=>(isset($rowChunk[1]) ? $rowChunk[1] : '')));
            $output .= $chunk->process($rowArr);
        }
    }
    
    if(strlen($output)>0){
        $chunk = $modx->newObject('modChunk');
        $chunk->fromArray(array('name'=>"@INLINE-".uniqid(),'snippet'=>(isset($rowChunk[0]) ? $rowChunk[0] : '')));
        $output = $chunk->process(array('inner'=>$output));
    }

}

return $output;
